%Script to evaluate results on the SBM-RGBD dataset
%
%Parameters to be changed:
datasetPath='../SBM_RGBDdataset/';                    %path to the dataset
binaryRootPath='../Software/FrameDifference/results/';%path to the results

%anything below here needs to be changed
categoryList = filesys('getFolders', binaryRootPath);

datasetStats = [];
evaluatedCategories = [];

for strCategory = categoryList,
    category = strCategory{1};
    categoryPath = fullfile(datasetPath, category);
    
    videoList = filesys('getFolders', categoryPath);
    
    if (length(videoList))
        fprintf('\n************* Category %s:\n',category);
        evaluatedCategories=[evaluatedCategories; strCategory];
    
        categoryStats = [];
        names = [];
        for strVideo = videoList,
            video = strVideo{1};
            videoPath = fullfile(categoryPath, video);
            binaryPath = fullfile(binaryRootPath, category, video);

            if exist(binaryPath, 'dir') 
                confusionMatrix = processVideoFolder(videoPath, binaryPath);
                [TP, FP, FN, TN, stats] = confusionMatrixToVar(confusionMatrix);
                categoryStats = [categoryStats; stats];
                nome='      ';
                nome(1:min(6,length(video)))=video(1:min(6,length(video)));
                names = [names; nome];
            else
                fprintf('ERROR: missing directory for video %s\n',video);
            end
        end

        fprintf('\nName\tRecall\t\tSpecificity\tFPR\t\tFNR\t\tPWC\t\tPrecision\tFMeasure\n');
        for j=1:size(names,1)
            fprintf('%s\t%1.10f\t%1.10f\t%1.10f\t%1.10f\t%1.10f\t%1.10f\t%1.10f\n', names(j,:),categoryStats(j,:));
        end
        meancategoryStats=mean(categoryStats,1);
        fprintf('AVG\t%1.10f\t%1.10f\t%1.10f\t%1.10f\t%1.10f\t%1.10f\t%1.10f\n', meancategoryStats);

        datasetStats = [datasetStats;meancategoryStats];
    end

end
fprintf('\n************* Average measures on all categories:************* \n'); disp(evaluatedCategories)
fprintf('Recall\t\tSpecificity\tFPR\t\tFNR\t\tPBC\t\tPrecision\tFMeasure\n');
fprintf('%1.10f\t%1.10f\t%1.10f\t%1.10f\t%1.10f\t%1.10f\t%1.10f\n', mean(datasetStats,1));



